#include "addnew.h"
#include "ui_addnew.h"
#include <QClipboard>
#include <QFileDialog>
#include <QDesktopServices>

AddNew::AddNew(QWidget *parent) :
    QDialog(parent),
    ui(new Ui::AddNew)
{
    ui->setupUi(this);
    ui->verticalLayout_3->setMargin(5);
    setFixedHeight(90);
    setLayout (ui->verticalLayout_3);

    ac = false;

    QClipboard *clipboard = QApplication::clipboard();

    const QString & url = clipboard->text();
    if ( url.startsWith("http://") || url.startsWith("https://") )
        ui->url->setText(url);

    ui->saveTo->setText(settings.value("UI/SaveTo").toString());
}

void AddNew::setURL(const QString &url)
{
    ui->url->setText(url);
}

AddNew::~AddNew()
{
    delete ui;
}

void AddNew::on_pushButton_clicked()
{
    const QString & folder = QFileDialog::getExistingDirectory(this , tr("Save file to") ,
                                                               QDesktopServices::storageLocation(QDesktopServices::DocumentsLocation));

    if ( ! folder.isEmpty() )
    {
        ui->saveTo->setText(folder);
    }
}

QString AddNew::getUrl()
{
    return ui->url->text();
}

QString AddNew::getSaveTo()
{
    return ui->saveTo->text();
}

void AddNew::on_buttonBox_accepted()
{
    ac = true;
    if ( ! ui->url->text().isEmpty() && ! ui->saveTo->text().isEmpty() )
    {
        settings.setValue("UI/SaveTo" , ui->saveTo->text());
        close();
    }
}

void AddNew::on_buttonBox_rejected()
{
    close();
}
