#ifndef DOWNLOADER_H
#define DOWNLOADER_H

#include <QObject>
#include <QProcess>
#include <QProgressBar>
#include <QLabel>
#include "config.h"
#include <QDebug>

class Downloader : public QObject
{
    Q_OBJECT
public:
    explicit Downloader(int id , QObject *parent = 0);

    void setOptions (const QString & opt)
    { aria2cOpt = opt; }

    void start();
    void stop ();

    void setFolder (const QString & folder);

    QString getFolder()
    { return cachedFolder; }

    void begin (const QString & url);

    QString getName()
    { return name->text(); }

    QString getUrl()
    { return cachedUrl; }

    QProgressBar *bar;
    QLabel *eta , *spd , *size , *name;
    QProcess *proc;

signals:
    void error(int id , const QString & err);
    void finished (int id );
    void infoUpdated ();

public slots:
    void readyRead ();
    void errorReady ();

private:
    QString cachedUrl , cachedFolder , aria2cOpt;
    int id;
};

#endif // DOWNLOADER_H
