#ifndef MAINWINDOW_H
#define MAINWINDOW_H

#include <QMainWindow>
#include <QStandardItemModel>
#include <QStandardItem>
#include <QInputDialog>
#include <QClipboard>
#include <QSystemTrayIcon>
#include <QMessageBox>
#include <QSettings>
#include <QFile>
#include <QDesktopServices>
#include <QDir>
#include <QUrl>
#include <QClipboard>

#include "downloader.h"
#include "tableviewx.h"

namespace Ui {
    class MainWindow;
}

class MainWindow : public QMainWindow
{
    Q_OBJECT

public:
    explicit MainWindow(QWidget *parent = 0);
    ~MainWindow();

    void msgbox (const QString & text);
    bool question (const QString & text);

private:
    Ui::MainWindow *ui;
    QDir dir;
    QVector<Downloader*> mapping;
    QMap<QString,QString> savedUrls;
    QSystemTrayIcon *trayIcon;
    QFile fp;
    TableViewX *tableWidget;

    QString aria2copts;

    void setupGUI();
    void loadSettings();
    void saveSettings();

public slots:
    void messageReceived (const QString & text);

private slots:
    void showOrHide(QSystemTrayIcon::ActivationReason reason);
    void infoUpdated ();
    void finished (int id);
    void errorString (int id , const QString & text);
    void addNew (const QString & url , const QString & folder);
    void on_actionAdd_New_triggered();
    void on_actionPause_triggered();
    void on_actionDelete_triggered();
    void on_actionStart_Continue_triggered();
    void on_actionAbout_triggered();
    void on_actionOpen_Folder_triggered();
    void on_actionQuit_triggered();
    void on_actionConfigure_Aria2c_triggered();
    void on_actionOpen_This_File_triggered();
    void on_actionCopy_link_address_triggered();
};

#endif // MAINWINDOW_H
